#include <reg51.h>
#include <stdio.h>
#include <i2c.h>

#define uchar unsigned char
#define WRITE 0xA0                       /* 24C04ַSLAͷλW */
#define READ 0xA1                        /* 24C04ַSLAͷλR */
#define BLOCK_SIZE 32                    /* ָֽڸ */
#define FALSE 0
#define TRUE ~FALSE

xdata uchar EAROMImage[BLOCK_SIZE];/* ⲿRAMж洢ӳԪ */

/****************************************************************************
*    ԭ: bit E_address(uchar Address);
*        : 24C04дַһָֽڵַ
*****************************************************************************/
bit E_address( uchar Address ) {
	I_start() ;
	if ( I_send( WRITE ) )
		return ( I_send( Address ) ) ;
	else
		return ( FALSE ) ;
}

/****************************************************************************
*    ԭ: bit E_read_block(void);
*        : 24C04жȡBLOCK_SIZEֽڵݲתⲿRAM洢ӳ
*              Ԫ, жʽƬ0ַʼȡݡ
*              24C04ָĵַ򷵻0(FALSE)
*****************************************************************************/
bit E_read_block( void ) {
	uchar i ;
	/* ӵַ0ʼȡ */
	if ( E_address( 0 ) ) {
		/* ظź */
		I_start() ;
		if ( I_send( READ ) ) {
			for ( i=0 ; i<=BLOCK_SIZE ; i++ ) {

				EAROMImage[i] = ( I_receive() ) ;
				if ( i != BLOCK_SIZE ) I_Ack() ;
				else {
					I_clock() ;
					I_stop() ;
				}
			}
			return ( TRUE ) ;
		}
		else {
			I_stop() ;
			return ( FALSE ) ;
		}
	}
	else
		I_stop() ;
		return ( FALSE ) ;
}

/****************************************************************************
*    ԭ: void wait_5ms(void);
*        : ṩ5msʱ(ʱƵΪ12MHz)
*****************************************************************************/
void wait_5ms( void ) {
	int i ;
	for ( i=0 ; i<1000 ; i++ ) {
		;
	}
}

/****************************************************************************
*    ԭ: bit E_write_block(void);
*        : ⲿRAM洢ӳԪед뵽24C04ͷBLOCK_SIZEֽڡ
*              ֽдʽ, ÿдʱҪָƬڵַ24C04
*              ָĵַĳ͵ֽδյӦźACK, 򷵻0
*              (FALSE)
*****************************************************************************/
bit E_write_block( void ) {
	uchar i ;
	for ( i=0 ; i<=BLOCK_SIZE ; i++ ) {
		if ( E_address(i) && I_send( EAROMImage[i] ) ) {
			I_stop() ;
			wait_5ms();
		}
		else
			return ( FALSE ) ;
	}
	return ( TRUE ) ;
 }

void  main() {
    SCON = 0x5a;        
    TMOD = 0x20;  
    TCON = 0x69;  
    TH1 =  0xfd; 
	I_init();                         /* I2C ߳ʼ */
	if (E_write_block())
		 printf("write I2C good.\r\n");
	else
		 printf("write I2C bad.\r\n");
	if (E_read_block()) 
		printf("read I2C good.\r\n");
	else
		 printf("read I2C bad.\r\n");
	while(1);
}
		
