/* =========================================================================
*     I2C߻
* =========================================================================*/
/* ȫַŶ */
#define HIGH 1
#define LOW 0
#define FALSE 0
#define TRUE ~FALSE
#define uchar unsigned char
sbit SCL		= 0x96 ;
sbit SDA		= 0x97 ;


/****************************************************************************
*    ԭ: void delay(void);
*        : ʵֻһָ, ھӦпӾҪʱ 
*              ָ
****************************************************************************/
void delay( void ) {
	;
 }

/****************************************************************************
*    ԭ: void I_start(void);
*        : ṩI2C߹ʱеʼλ                             
****************************************************************************/
void I_start( void ) {
	SCL = HIGH ;
	delay() ;
	SDA = LOW ;
	delay() ;
	SCL = LOW ;
	delay() ;
 }

/****************************************************************************
*    ԭ: void I_stop(void);
*        : ṩI2C߹ʱеֹͣλ
****************************************************************************/
void I_stop( void ) {
	SDA = LOW ;
	delay() ;
	SCL = HIGH ;
	delay() ;
	SDA = HIGH ;
	delay() ;
	SCL = LOW ;
	delay() ;
 }

/****************************************************************************
*    ԭ: void I_init(void);
*        : I2C߳ʼmain()Ӧȵñ, Ȼٵ
*              
****************************************************************************/
void I_init( void ) {
	SCL = LOW ;
	I_stop() ;
}

/****************************************************************************
*    ԭ: bit I_clock(void);
*        : ṩI2Cߵʱź, ʱӵƽΪڼSDA ź״
*              ̬ݷ, Ҳݽա
****************************************************************************/
bit I_clock( void ) {
	bit sample ;
	SCL = HIGH ;
	delay() ;
	sample = SDA ;
	SCL = LOW ;
	delay() ;
	return ( sample ) ;
 }

/****************************************************************************
*    ԭ: bit I_send(uchar I_data);
*        : I2C߷8λ, һӦźACKյACKӦ
*              򷵻1(TRUE), 򷵻0(FALSE)
****************************************************************************/
bit I_send( uchar I_data ) {
	uchar i ;
	/* 8λ */
	for ( i=0 ; i<8 ; i++ ) {
		SDA = (bit)( I_data & 0x80 ) ;
		I_data = I_data << 1 ;
		I_clock() ;
	}
	/* ӦźACK */
	SDA = HIGH ;
	return ( ~I_clock() );
  }

/****************************************************************************
*    ԭ: uchar I_receive(void);
*        : I2CϽ8λź, յ8λΪһֽ
*              , ӦźACKڵñ֮ǰӦ֤SDA
*              ߴڸ״̬, ʹ8051P1.71
****************************************************************************/
uchar I_receive( void ) {
	uchar I_data = 0 ;
	register uchar i ;
	for ( i=0 ; i<8 ; i++ ) {
		I_data *= 2 ;
		if (I_clock()) I_data++ ;
	}
	return ( I_data ) ;
}

/****************************************************************************
*    ԭ: void I_Ack(void);
*        : I2C߷һӦźACK, һݶȡʱ
*****************************************************************************/
void I_Ack( void ) {
	SDA = LOW ;
	I_clock() ;
	SDA = HIGH ;
}

